;       Compile with WLA-6510 (http://www.hut.fi/~vhelin/wla.html)

.MEMORYMAP
DEFAULTSLOT 0
SLOTSIZE $ffff
SLOT 0 $0000
.ENDME

.ROMBANKMAP
BANKSTOTAL 1
BANKSIZE $ffff
BANKS 1
.ENDRO

.BANK 0


.DEFINE LoadAddr        $0801

.ORG $0
.SECTION "BANKHEADER"
        .dw     LoadAddr
.ENDS


.DEFINE cardec          $f0
.DEFINE linedec         $f7

.DEFINE xadd            $fa

.DEFINE speed           $fe
.DEFINE speedl          $fd

.DEFINE liney           $ff


.ORG LoadAddr
.SECTION "MAIN" FORCE
        .DB     $0b,$08,$01,$00,$9e,$32,$30,$35,$39     ;"1 sys2059"
        .DB     $00

        ldy     #$00
_sprlp:
        lda     #$ff
_spr:
        sta     $26f7,y                 ; fill screen and car sprite
        sta     $37f8,y                 ; define block character
_color:
        sta     $db00,y
        iny
        bne     _sprlp
        dec.w   _color+2
        lda     #$11
        dcp.w   _spr+2
        bne     _sprlp

        ldx     #$08
_hol:
        lda.w   carwin,x                ; car sprite windows
        sta.w   $238c,x
        sta.w   $23a4,x
        sta.w   $23d2,x
        sta.w   $23ea,x

        lda.w   sprshape,x              ; sprite shapes
        sta.w   $27f8,x
        tya
        sta.w   $37b8,x                 ; define clear space character(s)
        dex
        bpl     _hol

        sty     $dc0e                   ; stop timer

        ldx     #$05
_lines:
        lda.w   lineaddr,x
        sta     $fc
        lda     #$00
        sta     $fb
        lda.w   linemap,x
        tay
        lda     #$19
        sta     $ef
_linlp:
        lda     #$f7                    ; space char or yellow color
        sta     ($fb),y
        lda     $fb
        clc
        adc     #$28
        sta     $fb
        bcc     _lnoc
        inc     $fc
_lnoc:
        dec     $ef
        bne     _linlp

        dex
        bpl     _lines


_newgame:
        sei

        ldx     #$2f
_vicinit:
        lda.w   SID-1,x
        sta.w   $d3ff,x

        lda.w   VICII-1,x                 ; video setup
        sta.w   $cfff,x
        dex
        bne     _vicinit

        lda     #irq&255                ; irq setup
        sta     $0314
        lda     #irq/256
        sta     $0315

        stx     speedl                  ; $00
        stx     xadd
        stx     $02
        inx
        stx     speed                   ; $01

        lda     #$0f
_clrscore:
        sta.w   $d800,x
        inx
        inx
        bpl     _clrscore

        cli

_gameplay:
        lda     $02
        bpl     _gameplay

_crash:
        stx     $d404                   ; explosion
        inx
        stx     $d02e

        lda     #$00
        sta     $d40b
        sta     $d412
        sta     speed
        sta     speedl
_waitbutton:
        lda     $dc00
        and     #$10
        bne     _waitbutton
        beq     _newgame


;-----  raster interrupt

irq:
        lsr     $d019

_nextline:
        lda     $d021                   ; switch between line/no line
        eor     #$0e
        sta     $d021

        lda     liney
        clc
        adc     #$20

        bcs     _frameroutine

        sta     liney
        sta     $d012

        pla
        tay
        pla
        tax
        pla

        rti


_frameroutine:
        pha

        lda     $d01f                   ; own car still on-road?
        and     #$80
        eor     #$80
        ora     $d01e                   ; sprite collisions
        sta     $02

        ldx     #$00                    ; wait for end of frame
_waitend:
        cpx     $d012
        bne     _waitend

        lda     linedec                 ; speed decimal bits
        clc
        adc     speedl
        sta     linedec

        pla
        adc     speed                   ; speed
        sta     liney

        ldy     #$0a
        ldx     #$06
        lda     #$40
        sta     $f8
_movecars:
        lsr     $f8                     ; car sprite bit

        lda     $f8                     ; don't move crashed cars
        and     $02
        bne     _nextcar

        lda     cardec-1,x              ; car position decimal bits
        adc     speedl                  ; speed decimal bits
        sta     cardec-1,x
        lda     $d001,y
        adc     speed
        clc
        adc.w   carspeeds-1,x
        sta     $d001,y

        cmp     #$09                    ; randomize cars
        bcs     _nextcar
        lda     $d015                   ; sometimes no car
        eor     $f8
        sta     $d015

_nextcar:
        dey
        dey
        dex
        bne     _movecars

        lda     speed                   ; no move if dead
        beq     _nextline

        lda     $dc00                   ; read joystick in port 2
        ldy     xadd
        cmp     #123
        bne     _notjoyleft

        dey
        dey
        bne     _joyed

_notjoyleft:
        cmp     #119
        bne     _nojoy

        iny
        iny

_joyed:
        lda     speedl                  ; wheel squeek
        and     #$07
        ror
        ror
        sbc     #$14
        tax
_nojoy:
        stx     $d40f

        sty     xadd
        tya
        bpl     _right

        inc     xadd
        lsr
        lsr
        ora     #$c0
        jsr     _ownadd
        bcs     _ownstill
        bcc     _owncarok
_right:
        dec     xadd
        lsr
        lsr
        jsr     _ownadd
        bcc     _ownstill
_owncarok:
        lda     $d010
        eor     #$80
        sta     $d010
_ownstill:

        ldy     speedl                  ; no brakes!
        iny
        sty     speedl
        bne     _nostc

        inc     speed
        lax     speed
        stx     $d408

        asl
        tax
        lda     #$0d
        sta.w   $d7fd,x                 ; speedometer

_nostc:
        sty     $d407

        jmp     _nextline


_ownadd:
        clc
        adc     $d00e
        sta     $d00e
        rts


;-----  tables & variables

linemap:
        .DB     $06,$0c,$1a,$20,$12,$14
lineaddr:
        .DB     $24,$24,$24,$24,$d8,$d8

carspeeds:
        .DB     $fe,$fc,$f9,$04,$03                     ;stripped last $01
SID:
        .DB     $01,$0a,$00,$00,$00,$0a,$0a
        .DB     $00,$02,$00,$00,$21,$00,$f0
        .DB     $ff,$02,$00,$00,$23,$00,$f0

        .DB     $00,$50,$f6,$1f

VICII:
        .DB     $2c,$00,$fc,$00,$cc,$00,$8c,$00         ;$d000-$d007
        .DB     $5c,$00,$2c,$00,$00,$00,$34,$b0         ;$d008-$d00f
        .DB     $81,$1b,$00,$00,$00,$92,$04,$ff         ;$d010-$d017
        .DB     $9c,$00,$01,$00,$ff,$00,$00,$00         ;$d018-$d01f
        .DB     $0b,$01,$00,$00,$00,$0b,$00,$0f         ;$d020-$d027
        .DB     $0f,$0f,$0f,$0f

sprshape:
        .DB     $8f,$8f,$8f,$8e,$8e,$8e,$8f,$8f

carwin:
        .DB     $da,$aa,$a7,$da,$aa,$a7,$da,$aa,$a7
.ENDS
